﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
//using System.IO;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.System.UserProfile;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;
using Windows.UI.Xaml.Navigation;

//“空白页”项模板在 http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409 上有介绍

namespace 设置壁纸
{
    /// <summary>
    /// 可用于自身或导航至 Frame 内部的空白页。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        ImgFile imgFile;
        public MainPage()
        {
            this.InitializeComponent();
            imgFile = new ImgFile();
            Binding bind = new Binding();
            bind.Converter = new ValueConverter();
            bind.Source = imgFile;
            bind.Path = new PropertyPath("Index");
            bind.Mode = BindingMode.OneWay;
            btnSetWallpaper.SetBinding(Button.IsEnabledProperty, bind);

            Binding bindIndex = new Binding();

            bindIndex.Source = imgFile;
            bindIndex.Path = new PropertyPath("Index");
            bindIndex.Mode = BindingMode.TwoWay;
            flipView.SetBinding(FlipView.SelectedIndexProperty, bindIndex);
            
        }
        public async void LoadLocalImg()
        {
            if (imgFile == null)
            {
                imgFile = new ImgFile();
            }
            if (imgFile.Imgs != null)
            {
                imgFile.Imgs.Clear();
            }
            var picker = new FolderPicker();
            picker.FileTypeFilter.Add(".jpg");
            picker.FileTypeFilter.Add(".jpeg");
            picker.FileTypeFilter.Add(".png");
            picker.SuggestedStartLocation = PickerLocationId.PicturesLibrary;
            picker.ViewMode = PickerViewMode.Thumbnail;
            var folder=await picker.PickSingleFolderAsync();

            if (folder != null)
            {
                 //var lists=await Windows.Storage.ApplicationData.Current.LocalFolder.GetFilesAsync();
                var lists = await folder.GetFilesAsync();
                string[] types = { ".jpg", ".jpeg", ".png" };
                var files = from d in lists
                            where d.FileType.Contains(".png")
                            select d;
                imgFile.Imgs = files.ToList();
                //imgFile.Imgs = lists.Where(m => m.FileType==".png")..ToList();
                
                if (imgFile != null && imgFile.Imgs.Count > 0)
                {
                    imgFile.Index = 0;
                    flipView.ItemsSource = imgFile;
                    //var img = imgFile.Imgs[imgFile.Index];
                    //var imgSteam = await img.OpenStreamForReadAsync();

                    //BitmapImage bitmap = new BitmapImage();
                    //bitmap.SetSource(imgSteam.AsRandomAccessStream());
                    //imgShow.Source = bitmap;
                }
            }
            
        }
        private async void Check(object sender, RoutedEventArgs e)
        {
            if (UserProfilePersonalizationSettings.IsSupported() == true)
            {
                await new MessageDialog("可以设置壁纸哦~").ShowAsync();
            }
            else
            {
                btnSetWallpaper.IsEnabled = false;
                await new MessageDialog("不支持设置壁纸哦~").ShowAsync();
            }
        }

        private async void btnSetWallpaper_Click(object sender, RoutedEventArgs e)
        {
            if (imgFile == null || imgFile.Imgs == null || imgFile.Imgs.Count <= 0)
            {
                return; 
            }
            
            var current = UserProfilePersonalizationSettings.Current;
            StorageFile img = imgFile.Imgs[imgFile.Index];
            var localFolder = Windows.Storage.ApplicationData.Current.LocalFolder;
            var newFile=await img.CopyAsync(localFolder,img.Name, NameCollisionOption.ReplaceExisting);
            bool re = await current.TrySetWallpaperImageAsync(newFile);
            if (re == true)
            {
                await new MessageDialog("设置成功").ShowAsync();
                //await newFile.DeleteAsync();
            }
            else
            {
                await new MessageDialog("设置失败了").ShowAsync();
            }
        }

        private async void btnNext_Click(object sender, RoutedEventArgs e)
        {
            
            
            if ((string)((Button)sender).Tag == "Next")
            {
                imgFile.Index++;
              
            }
            else
            {
                imgFile.Index--;
            }
            if (imgFile.Index != -1)
            {
                //var img = imgFile.Imgs[imgFile.Index];
                //var imgSteam = await img.OpenStreamForReadAsync();

                //BitmapImage bitmap = new BitmapImage();
                //bitmap.SetSource(imgSteam.AsRandomAccessStream());
                //imgShow.Source = bitmap;
            }
            else
            {
                await new MessageDialog("没有可用图片").ShowAsync();
            }
            
        }

        private void btnLoad_Click(object sender, RoutedEventArgs e)
        {
            LoadLocalImg();
        }

        private async void btnSelectFolder_Click(object sender, RoutedEventArgs e)
        {
            var picker = new FolderPicker();
            picker.FileTypeFilter.Add(".jpg");
            picker.FileTypeFilter.Add(".jpeg");
            picker.FileTypeFilter.Add(".png");
            picker.SuggestedStartLocation = PickerLocationId.PicturesLibrary;
            picker.ViewMode = PickerViewMode.Thumbnail;
            var folder = await picker.PickSingleFolderAsync();

            if (folder != null)
            {
                //var lists=await Windows.Storage.ApplicationData.Current.LocalFolder.GetFilesAsync();
                var lists = await folder.GetFilesAsync();
                imgFile.Imgs = lists.ToList();

                if (imgFile != null && imgFile.Imgs.Count > 0)
                {
                    flipView.ItemsSource = imgFile.Imgs;
                    imgFile.Index = 0;
                    
                    //var img = imgFile.Imgs[0];
                    //var imgSteam = await img.OpenStreamForReadAsync();

                    //BitmapImage bitmap = new BitmapImage();
                    //bitmap.SetSource(imgSteam.AsRandomAccessStream());
                    ////imgShow.Source = bitmap;
                    //flipView.Items.Add(bitmap);
                }
            }

        }
        

    }
    public  class ImgFile:INotifyPropertyChanged
    {
        private IList<StorageFile> _imgs;
        public IList<StorageFile> Imgs
        {
            get { return _imgs; }
            set
            {
                _imgs = value;
                if (PropertyChanged != null)
                {
                    OnPropertyChanged();
                }
            }
        }
        private int _index;
        public int Index
        {
            get
            {
                if (Imgs == null || Imgs.Count <= 0)
                {
                    return -1;
                }
                else
                    return _index;
            }
            set
            {
                if (Imgs == null || Imgs.Count == 0)
                {
                    _index = -1;
                }
                else if (value >= Imgs.Count)
                {
                    _index = 0;
                }
                else if (value < 0)
                {
                    _index = Imgs.Count - 1;
                }
                else
                {
                    _index = value;
                }
                OnPropertyChanged();
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged([CallerMemberName]string propertyName="")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        public ImgFile()
        {
            Index = -1;
        } 
    }

    public class ValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            if ((int)value < 0)
            {
                return false;
            }
            else
            {
                return true;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }
    public class ImageConverter : IValueConverter
    {
        public  object Convert(object value, Type targetType, object parameter, string language)
        {
            var storageFile = (StorageFile)value;
            BitmapImage bitimg = new BitmapImage();
            OpenSteam(bitimg, storageFile);
            //Image img = new Image();
            //img.Source = bitimg;
            return bitimg;
        }
        private async void OpenSteam(BitmapImage bitmap,StorageFile storageFile)
        {
            using (var stream = await storageFile.OpenStreamForReadAsync())
            {
                bitmap.SetSource(stream.AsRandomAccessStream());
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }
}
